var camDevices=null;

function onError(err) {
	var statusElement = document.getElementById('status');
	var msg = err.message;
	if( err.name == 'CannotEnumDevices')
		msg += ' check HTTPS';
	statusElement.innerHTML = 'Error (' + err.name + '): ' + msg;
}

function SelectBestCamera(camArr) {
	var _result = -1;
	var minCamIdx = 9999;
	for( var i=0; i < camArr.length; ++i ) {
		var matchArr = camArr[i].label.match(/[a-z0-9]+\s+(\d)+,.*(back).*/i);
		if( matchArr && matchArr.length == 3 && parseInt(matchArr[1]) < minCamIdx )
			_result = i;
	};

	return _result;
}

function CreateScanner(){
	var barDataEl = document.getElementById( 'datasymbol-barcode-viewport' );
	if( barDataEl == null )
		return;

	DSScanner.addEventListener('onBarcode', onBarcodeReady);

	DSScanner.addEventListener('onScannerReady', function () {
		console.log('HTML onScannerReady');
		var statusElement = document.getElementById('status');
		if(statusElement != null)
			statusElement.innerHTML = ' ';	//statusElement.hidden = true;
		DSScanner.StartScanner();
	});

	if( scannerSettings.camera.facingMode == 'environment') {
		var camIdx = SelectBestCamera( camDevices );
		if( camIdx >= 0 )
			scannerSettings.camera.id = camDevices[camIdx].id;
	}

	DSScanner.Create(scannerSettings);
}

function OnResize() {
	document.getElementById('datasymbol-barcode-viewport').setAttribute('style', 'margin:0;padding:0');	//wp for unknown reasons changes style of video element (sets height:0)
}

function OnWindowLoad()
{
	window.addEventListener('resize', OnResize, false);

	DSScanner.addEventListener('onError', onError);

	DSScanner.getVideoDevices(function (devices) {
		devices.forEach(function (device) {
			console.log("device:" + device.label + '|' + device.id);
		});
		if(devices.length > 0)
		{
			camDevices = devices.slice();
			CreateScanner();
		}
		else
		{
			onError( {name: 'NotFoundError', message: ''} );
		}
	});
}

window.addEventListener("load", OnWindowLoad);



